#!/sbin/sh

mkdir /tmp/ramdisk
cp /tmp/boot.img-ramdisk.gz /tmp/ramdisk/
cd /tmp/ramdisk/

echo "Unpacking ramdisk"
gunzip -c /tmp/ramdisk/boot.img-ramdisk.gz | cpio -i
cd /

echo "Copying modules to ramdisk for KitKat support"
if busybox [ -d ./lib/modules ]; then
    rm -rf /tmp/ramdisk/lib    # Delete all Modules so we have only our modules inside the ramdisk
fi

mkdir /tmp/ramdisk/lib/
#find -name '/system/lib/modules/*.ko' | xargs {} cp {} /tmp/ramdisk/lib/modules/
cp -r /system/lib/modules/* /tmp/ramdisk/lib/modules

echo "Editing ramdisk if needed...";
echo ""

sed -i 's/ro.adb.secure=1/ro.adb.secure=0/' /tmp/ramdisk/default.prop

sed -i 's/ro.secure=1/ro.secure=0/' /tmp/ramdisk/default.prop

sed -i 's/write \/proc\/sys\/kernel\/dmesg_restrict 1/write \/proc\/sys\/kernel\/dmesg_restrict 0/' /tmp/ramdisk/init.rc

#init.d support
param=$(grep '#init.d support' /tmp/ramdisk/init.rc)
if [ "$param" = '#init.d support' ]; then
	echo "init.d already supported"
else
	echo "Adding init.d support..."
	echo "" >> /tmp/ramdisk/init.rc
	echo "#init.d support" >> /tmp/ramdisk/init.rc
	echo "service sysinit /system/bin/logwrapper /system/xbin/busybox run-parts /system/etc/init.d" >> /tmp/ramdisk/init.rc
	echo "    class main" >> /tmp/ramdisk/init.rc
	echo "    user root" >> /tmp/ramdisk/init.rc
	echo "    group shell" >> /tmp/ramdisk/init.rc
	echo "    oneshot" >> /tmp/ramdisk/init.rc
	echo "" >> /tmp/ramdisk/init.rc
	
fi

param2=$(grep '#KSM' /tmp/ramdisk/init.pxa988.rc)
if [ "$param2" = '#KSM' ]; then
	echo "KSM already enabled"
else
	echo "Enabling KSM..."
	echo "" >> /tmp/ramdisk/init.pxa988.rc
	echo "#KSM" >> /tmp/ramdisk/init.pxa988.rc
	echo "write /sys/kernel/mm/ksm/pages_to_scan 100" >> /tmp/ramdisk/init.pxa988.rc
	echo "write /sys/kernel/mm/ksm/sleep_millisecs 500" >> /tmp/ramdisk/init.pxa988.rc
	echo "write /sys/kernel/mm/ksm/deferred_timer 1" >> /tmp/ramdisk/init.pxa988.rc
	echo "write /sys/kernel/mm/ksm/run 1" >> /tmp/ramdisk/init.pxa988.rc
	echo "" >> /tmp/ramdisk/init.pxa988.rc
fi
	
rm /tmp/ramdisk/boot.img-ramdisk.gz
rm /tmp/boot.img-ramdisk.gz
cd /tmp/ramdisk/

echo "Repacking ramdisk"
find . | cpio -o -H newc | gzip > ../ramdisk-new.cpio.gz
cd /
#rm -rf /tmp/ramdisk

